/* FotoPad 0.95
 * (C) MAR-APR 2001 Hynek Sladky
 * sladky@mujmail.cz
 */

#pragma pack(2)
#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <System/Graffiti.h>

#include "FotoPadR.h"
#include "FotoPad.h"

/*
TO DO:
* add response to SysApp...Find and view for this items
*/

// forward function definitions
static int StartApplication (void);
static int CreateData (void);
static Boolean OpenDatabase (int init);
static void UpdateRecordForm (void);
static void UnLoadData (void);
static void UnLoadPrefs (void);
static void EventLoop (void);
static void StopApplication (void);
static Boolean FotoPadEnter (EventPtr event);
static Boolean FotoPadPrefs (EventPtr event);
static int EnterValue (char *val, Boolean sel);

// global variables definitions
// preferences database
DmOpenRef   PrefsDB;
struct sPrefs Prefs;
char        PrefsName[] = "FotoPadPrefs";
// film database
DmOpenRef   FilmDB;
char        FilmName[16];
char        NoneFilter[24]; // bylo 8,8,8, ale zvetseno kvuli prekladum
char        NoneCorrec[24];
char        UnlistedSpeed[24];
char        ctl_number[6], ctl_date[12], ctl_time[12];
char        *ctl_lens, *ctl_flength, *ctl_aperture, *ctl_speed, *ctl_filter, *ctl_correc;
struct sRecord Record;
struct sView ViewRec;
UInt        card;
int         FilmSel;
// form variables
VoidHand    descripHnd, ListHnd, FnameHnd, valueHnd;
UInt        Index;
int         ActiveForm;
int         PrefsCat, PrefsObj, PrefsMax, PrefsPos;
char        *ListStr, *FnameStr;
char        *FilmPtr[MAXfilm], *LensPtr[MAXlens], *FocalPtr[MAXfocal], *AperturePtr[MAXaperture], *SpeedPtr[MAXspeed], *CorrecPtr[MAXcorrec], *FilterPtr[MAXfilter], *PrefsPtr[MAXprefs];
int         FilmCnt, LensCnt, FocalCnt, ApertureCnt, SpeedCnt, CorrecCnt, FilterCnt, PrefsCnt;

// Entry point
DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags) {
int error;

  if (cmd == sysAppLaunchCmdNormalLaunch) {
    if (error = StartApplication()) return error;
    EventLoop ();
    StopApplication ();
  }
  return 0;
}

// startup setup
static int StartApplication(void) {
int error;
  ActiveForm=0;
  if (error = CreateData ()) return error;
  if (error = OpenDatabase (2)) return error;
  FrmGotoForm (record_form);
  return 0;
}

// Record fill with zero
void ClearRecord (void) {
char    *s;
int     i;
  s=(char*)&Record;
  for (i=sizeof (struct sRecord); i; i--, s++) *s='\0';
}

// allocate dynamic structures
static int CreateData (void) {
int i, ofs;
  if ((descripHnd=MemHandleNew (DescripSize))==NULL) return 1;
  if ((ListHnd=MemHandleNew (LensSize*MAXlens+FocalSize*MAXfocal+ApertureSize*MAXaperture+SpeedSize*MAXspeed+CorrecSize*MAXcorrec+FilterSize*MAXfilter))==NULL) return 1;
  ListStr=MemHandleLock (ListHnd);
  if ((FnameHnd=MemHandleNew (FnameSize*MAXfilm))==NULL) return 1;
  FnameStr=MemHandleLock (FnameHnd);
  if ((valueHnd=MemHandleNew (MAXsize))==NULL) return 1;
  for (i=ofs=0; i<MAXfilm; i++, ofs+=FnameSize) FilmPtr[i]=&FnameStr[ofs];
  ctl_lens=NULL;
  return 0;
}

// write record to database
static void WriteRecord (struct sRecord *ptr) {
int             structsize, i;
VoidHand        RecHandle;

  structsize = sizeof (struct sRecord) - DescripSize + StrLen (ptr->descrip) + 1;
  if (!DmNumRecords (FilmDB) || Index>DmNumRecords (FilmDB)-1) {
    RecHandle = DmNewRecord (FilmDB, &Index, structsize);
  } else {
    RecHandle = DmGetRecord (FilmDB, Index);
  }
  i=MemHandleSize (RecHandle);
  if (i<structsize || i>structsize+MaxDifference) {
    RecHandle=DmResizeRecord (FilmDB, Index, structsize);
    if (RecHandle==NULL) return; // FATAL ERROR!!!???
  }
  DmWrite (MemHandleLock (RecHandle), 0, &Record, structsize);
  MemHandleUnlock (RecHandle);
  DmReleaseRecord (FilmDB, Index, true);
  return;
}

// open preferences database
// init==2 open preferences database, open film database used last
// init==1 open selected film  database
static Boolean OpenDatabase (int init) {
VoidHand    RecHandle;
Ptr         RecPointer;
UInt        idx=0;
int         i, ofs;
DmSearchStateType   Srch;
LocalID     db_id=0;
Err         error;
char        Last[FnameSize];

// open preferences database
// preferences must be in database because I want to distribute them with the program; I can database export easily
  if (init==2) {
    PrefsDB = DmOpenDatabaseByTypeCreator (PrefsDBType, AppID, dmModeReadWrite);
    if (!PrefsDB) {
      if (DmCreateDatabase (0, PrefsName, AppID, PrefsDBType, false)) return 1;
      db_id=DmFindDatabase (card, PrefsName);
      DmDatabaseInfo (card, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      idx|=dmHdrAttrBackup;
      DmSetDatabaseInfo (card, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      PrefsDB = DmOpenDatabaseByTypeCreator (PrefsDBType, AppID, dmModeReadWrite);
      RecHandle = DmNewRecord (PrefsDB, &idx, sizeof (struct sPrefs));
      RecPointer = MemHandleLock (RecHandle);
      DmWrite (RecPointer, 0, &Prefs, sizeof (struct sPrefs));
      MemPtrUnlock (RecPointer);
      DmReleaseRecord (PrefsDB, idx, true);
    }
// load preferences to the variable
    RecPointer=MemHandleLock (DmQueryRecord (PrefsDB, 0));
    MemMove (&Prefs, RecPointer, sizeof(struct sPrefs));
    MemPtrUnlock (RecPointer);
// load text resources
    StrCopy (FilmName, MemHandleLock (RecHandle=DmGetResource(strRsc, str_dfilm)));
    MemHandleUnlock (RecHandle); DmReleaseResource (RecHandle);
    StrCopy (UnlistedSpeed, MemHandleLock (RecHandle=DmGetResource (strRsc, str_uspeed)));
    MemHandleUnlock (RecHandle); DmReleaseResource (RecHandle);
    StrCopy (NoneCorrec, MemHandleLock (RecHandle=DmGetResource (strRsc, str_noneC)));
    MemHandleUnlock (RecHandle); DmReleaseResource (RecHandle);
    StrCopy (NoneFilter, MemHandleLock (RecHandle=DmGetResource (strRsc, str_noneF)));
    MemHandleUnlock (RecHandle); DmReleaseResource (RecHandle);
// get all films names
    error=DmGetNextDatabaseByTypeCreator (true, &Srch, FilmDBType, AppID, false, &card, &db_id);
    FilmCnt=0;
    while (!error && db_id) {
      DmDatabaseInfo (card, db_id, FilmPtr[FilmCnt], NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      FilmCnt++;
      error=DmGetNextDatabaseByTypeCreator (false, &Srch, FilmDBType, AppID, false, &card, &db_id);
    }
    if (!FilmCnt) {
      StrCopy (FilmPtr[0], FilmName);
      FilmCnt++;
    }
// try to get film name last used from unsaved preferences
    *Last='\0';
    if (PrefGetAppPreferences (AppID, 0, NULL, &idx, false)!=noPreferenceFound) if (idx<=FnameSize) PrefGetAppPreferences (AppID, 0, Last, &idx, false);
// search for film last used in names array
    FilmSel=0;
    if (*Last) for (i=0; i<FilmCnt; i++) if (!StrCompare (FilmPtr[i], Last)) {FilmSel=i; break;}
  }
  if (init) { // ==1 || ==2
    Index=0;
    FilmDB=0;
    db_id=DmFindDatabase (card, FilmPtr[FilmSel]);
    if (FilmCnt && db_id) FilmDB=DmOpenDatabase (card, db_id, dmModeReadWrite);
// if the database don't exist, create new one
    if (!FilmDB) {
      if (DmCreateDatabase (0, FilmPtr[FilmSel], AppID, FilmDBType, false)) return 1;
      db_id=DmFindDatabase (card, FilmPtr[FilmSel]);
      DmDatabaseInfo (card, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      idx|=dmHdrAttrBackup;
      DmSetDatabaseInfo (card, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      FilmDB = DmOpenDatabase (card, db_id, dmModeReadWrite);
      ClearRecord ();
      WriteRecord (&Record);
    }
    Index=DmNumRecords (FilmDB)-1;
  }
  return 0;
}

// unload data, close databases, free dynamic structures
static void StopApplication (void) {
  if (ActiveForm==record_form) UnLoadData ();
  if (ActiveForm==prefs_form) UnLoadPrefs ();
// store film name last used
  PrefSetAppPreferences (AppID, 0, 0, FilmPtr[FilmSel], FnameSize, false);
  if (PrefsDB) DmCloseDatabase (PrefsDB);
  if (FilmDB) DmCloseDatabase (FilmDB);
  if (descripHnd==NULL) return;
  MemHandleFree (descripHnd);
  if (ListHnd==NULL) return;
  MemHandleUnlock (ListHnd);
  MemHandleFree (ListHnd);
  if (FnameHnd==NULL) return;
  MemHandleUnlock (FnameHnd);
  MemHandleFree (FnameHnd);
  if (valueHnd==NULL) return;
  MemHandleFree (valueHnd);
}

// conversion functions
char *FocalToStr (char *s, int i) {
  StrPrintF (s, "%umm", i);
  return s;
}
char *SpeedToStr (char *s, int i) {
  if (i<0)
    StrPrintF (s, "1/%d", -i);
  else
  if (i%10)
    StrPrintF (s, "%d.%ds", i/10, i%10);
  else
    StrPrintF (s, "%ds", i/10);
  return s;
}
char *ApertureToStr (char *s, int i) {
  StrPrintF (s, "%u.%u", i/10, i%10);
  return s;
}
char *CorrecToStr (char *s, int i) {
  if (!i) {s[0]='-'; s[1]='\0'; return s;}
  i-=1000;
  if (i<0) {*s='-'; i=-i;} else *s='+';
  StrPrintF (s+1, "%d.%dEV", i/10, i%10);
  return s;
}
// conversion function String to FixedPoint in integer
// dec>=0, number of decimal digits
// dec=-1, speed recognition: 10s -> 10 or 1/10s -> -10
int StrGetVal (char *s, int dec) {
Boolean minus=false;
int     retval=0;

  while (*s==' ') s++;
  if (*s=='-') {minus=true; s++;}
  while (*s>='0' && *s<='9') {
    retval*=10;
    retval+=*s-'0';
    s++;
  }
  if (dec==-1 && *s!='/') dec=1;
  if (dec>0) {
    if (*s==',' || *s=='.') s++;
    while (dec && *s>='0' && *s<='9') {
      retval*=10;
      retval+=*s-'0';
      s++;
      dec--;
    }
    while (dec) {dec--; retval*=10;}
  } else
  if (dec==-1 && *s=='/') {
    minus=true;
    s++;
    retval=0;
    while (*s>='0' && *s<='9') {
      retval*=10;
      retval+=*s-'0';
      s++;
    }
  }
  return (minus)?-retval:retval;
}

// fill ViewRec strings with actual record data
void FillView (int updatetime) {
DateTimeType    DateTime;
// picture number
  StrIToA (ctl_number, (long) Index);
// date
  TimSecondsToDateTime (Record.DateTime, &DateTime);
  DateToAscii (DateTime.month, DateTime.day, DateTime.year, dfDMYWithDots, ctl_date);
// time
  TimeToAscii (DateTime.hour, DateTime.minute, tfColon24h, ctl_time);
  if (updatetime) return;
// focal
  FocalToStr (ViewRec.focal, Record.focal);
// aperture
  ApertureToStr (ViewRec.aperture, Record.aperture);
// speed
  SpeedToStr (ViewRec.speed, Record.speed);
// correction
  CorrecToStr (ViewRec.correc, Record.correc);
}

// scrollbar adjustment
static void UpdateScrollbar (FormPtr frm, UInt16 find, UInt16 sind) {
UInt16          currPos, txtHeight, fldHeight, maxValue;

  FldGetScrollValues (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, find)), &currPos, &txtHeight, &fldHeight);
  if (txtHeight>fldHeight) maxValue=txtHeight-fldHeight;
  else
  if (currPos) maxValue=currPos;
  else maxValue=0;
  SclSetScrollBar (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, sind)), currPos, 0, maxValue, fldHeight-1);
}
// field adjustment
static void ScrollLines (FormPtr frm, UInt16 find, UInt16 sind, int numLines, Boolean redraw) {
FieldPtr        fld;

  fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, find));
  if (numLines<0)
    FldScrollField (fld, -numLines, up);
  else
    FldScrollField (fld, numLines, down);
  if (FldGetNumberOfBlankLines (fld) && numLines<0 || redraw)
    UpdateScrollbar (frm, find, sind);
}

// filed text handle exchange
/*
static void FldChangeHandle (FormPtr formP, UInt16 objID, VoidHand textHandle) {
FieldPtr        fld;
VoidHand        hndl;

  fld=(FieldPtr)FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, objID));
  hndl=(VoidHand)FldGetTextHandle (fld);
  if (hndl!=NULL) {
    FldSetTextHandle (fld, NULL);
    MemHandleFree (hndl);
  }
  FldSetTextHandle (fld, (Handle) textHandle);
}
*/

// load last picture film data from database
// init==1 dynamic structures initialization
// init==2 w/o dyn. init., load data only
static void LoadData (int init) {
FormPtr     frm;
ControlPtr  ctl;
ListPtr     lst;
Ptr         p;
char        mask;
int         i, ofs, i2;
FieldPtr    fld;

  if ((frm=FrmGetFormPtr (record_form))==0) return;
// load last picture data
  if (init) {
    p=MemHandleLock (DmQueryRecord (FilmDB, Index));
    MemMove (&Record, p, MemPtrSize (p));
    MemPtrUnlock (p);
  }
// call filling function
  FillView (0);
// picture number
  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_picture)), ctl_number);
// date
  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_date)), ctl_date);
// time
  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_time)), ctl_time);
  if (init==1) {
// load string values
    if (ctl_lens==NULL) {
      ctl_lens=CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_lens)));
      ctl_flength=CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_focal)));
      ctl_aperture=CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_aperture)));
      ctl_speed=CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_speed)));
      ctl_filter=CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_filter)));
      ctl_correc=CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_correc)));
    }
// make pointer arrays
    for (i=ofs=0; i<MAXlens; i++, ofs+=LensSize) LensPtr[i]=&ListStr[ofs];
    for (i=0; i<MAXfocal; i++, ofs+=FocalSize) FocalPtr[i]=&ListStr[ofs];
    for (i=0; i<MAXaperture; i++, ofs+=ApertureSize) AperturePtr[i]=&ListStr[ofs];
    for (i=0; i<MAXspeed; i++, ofs+=SpeedSize) SpeedPtr[i]=&ListStr[ofs];
    for (i=0; i<MAXcorrec; i++, ofs+=CorrecSize) CorrecPtr[i]=&ListStr[ofs];
    for (i=0; i<MAXfilter; i++, ofs+=FilterSize) FilterPtr[i]=&ListStr[ofs];
// fill pointer arrays
    LensCnt=0;
    while (LensCnt<MAXlens && Prefs.lens[LensCnt][0]) {
      StrCopy (LensPtr[LensCnt], Prefs.lens[LensCnt]);
      LensCnt++;
    }
    SpeedCnt=0;
    while (SpeedCnt<MAXspeed && Prefs.speed[SpeedCnt]) {
      SpeedToStr (SpeedPtr[SpeedCnt], Prefs.speed[SpeedCnt]);
      SpeedCnt++;
    }
    if (SpeedCnt<MAXspeed) {
      StrCopy (SpeedPtr[SpeedCnt], UnlistedSpeed);
      SpeedCnt++;
    }
    StrCopy (CorrecPtr[0], NoneCorrec);
    CorrecCnt=1;
    while (CorrecCnt<MAXcorrec && Prefs.correc[CorrecCnt-1]) {
      CorrecToStr (CorrecPtr[CorrecCnt], Prefs.correc[CorrecCnt-1]);
      CorrecCnt++;
    }
    StrCopy (FilterPtr[0], NoneFilter);
    FilterCnt=1;
    while (FilterCnt<MAXfilter && Prefs.filter[FilterCnt-1][0]!='\0') {
      StrCopy (FilterPtr[FilterCnt],Prefs.filter[FilterCnt-1]);
      FilterCnt++;
    }
// set form's pointers to these arrays
    LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_lens)), LensPtr, LensCnt);
    LstSetHeight (lst, LensCnt);
    LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_speed)), SpeedPtr, SpeedCnt);
    LstSetHeight (lst, (SpeedCnt<8)?SpeedCnt:8);
    LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_correc)), CorrecPtr, CorrecCnt);
    LstSetHeight (lst, (CorrecCnt<8)?CorrecCnt:8);
    LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_filter)), FilterPtr, FilterCnt);
    LstSetHeight (lst, (FilterCnt<8)?FilterCnt:8);
  }
  lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_film));
  if (init) { // ==1 || ==2
    LstSetListChoices (lst, FilmPtr, FilmCnt);
    LstSetHeight (lst, (FilmCnt<8)?FilmCnt:8);
    CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_film)), FilmPtr[FilmSel]);
    LstSetSelection (lst, FilmSel);
  }
// lens
  PrefsObj=noListSelection;
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_lens));
  if (Record.lens[0]) {
    CtlSetLabel (ctl, Record.lens);
    for (i=0; i<MAXlens; i++) if (!StrCompare(Record.lens, Prefs.lens[i])) {PrefsObj=i; break;}
  } else
    CtlSetLabel (ctl, ctl_lens);
  LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_lens)), PrefsObj);
  mask=(PrefsObj!=noListSelection)?1<<PrefsObj:0xFF;
// dynamic focal and aperture change according to lens selected
//  if (init) //==1 || ==2
  UpdateRecordForm ();
// filter
  ofs=noListSelection;
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_filter));
  if (Record.filter[0]) {
    CtlSetLabel (ctl, Record.filter);
    for (i=0; i<MAXfilter; i++) if (!StrCompare(Record.filter, Prefs.filter[i])) {ofs=i+1; break;}
  } else
    CtlSetLabel (ctl, ctl_filter);
  LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_filter)), ofs);
// set focal length label
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_focal));
  if (Record.focal) CtlSetLabel (ctl, ViewRec.focal);
  else CtlSetLabel (ctl, ctl_flength);
// set aperture label
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_aperture));
  if (Record.aperture) CtlSetLabel (ctl, ViewRec.aperture);
  else CtlSetLabel (ctl, ctl_aperture);
// speed
  ofs=noListSelection;
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_speed));
  if (Record.speed) {
    CtlSetLabel (ctl, ViewRec.speed);
    for (i=0; i<MAXspeed; i++) if (Record.speed==Prefs.speed[i]) {ofs=i; break;}
  } else
    CtlSetLabel (ctl, ctl_speed);
  LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_speed)), ofs);
// correction
  ofs=noListSelection;
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_correc));
  if (Record.correc) {
    CtlSetLabel (ctl, ViewRec.correc);
    for (i=0; i<MAXcorrec; i++) if (Record.correc==Prefs.correc[i]) {ofs=i+1; break;}
  } else
    CtlSetLabel (ctl, ctl_correc);
  LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_correc)), ofs);
// check boxes
  CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_AE)), (Record.flags&AE)?1:0);
  CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_AElock)), (Record.flags&AElock)?1:0);
  CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_tripod)), (Record.flags&Tripod)?1:0);
  CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_flash)), (Record.flags&Flash)?1:0);
// description
  StrCopy (MemHandleLock (descripHnd), Record.descrip);
  MemHandleUnlock (descripHnd);
  FldSetTextHandle (fld=FrmGetObjectPtr (frm, i=FrmGetObjectIndex (frm, record_descrip)), (Handle)descripHnd);
  if (FrmGetFocus (frm)==i)
    FldSetInsertionPoint (fld, StrLen (Record.descrip));
  FldDrawField (fld);
  UpdateScrollbar (frm, record_descrip, record_scroll);
// show/hide unusable controls
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_next));
  if (Index<DmNumRecords (FilmDB)-1) CtlHideControl (ctl); else CtlShowControl (ctl);
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_plus));
  if (Index<DmNumRecords (FilmDB)-1) CtlShowControl (ctl); else CtlHideControl (ctl);
  ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_minus));
  if (!Index) CtlHideControl (ctl); else CtlShowControl (ctl);
// FrmUpdateForm (record_form);
  ActiveForm=record_form;
  return;
}

// form update after lens selection
static void UpdateRecordForm (void) {
FormPtr     frm;
ListPtr     lst;
int         i, ofs;
char        mask;

  if ((frm=FrmGetFormPtr (record_form))==0) return;
// version A
//  if ((obj=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_lens))))==noListSelection) return;
//  mask=1<<obj;
// version B
  i=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_lens)));
  mask=(i!=noListSelection)?1<<i:0xFF;
// focal and aperture dynamic change according to selected lens
  FocalCnt=i=0;
  while (i<MAXfocal && Prefs.focal[i].length) {
    if (Prefs.focal[i].category&mask) {
      FocalToStr (FocalPtr[FocalCnt], Prefs.focal[i].length);
      FocalCnt++;
    }
    i++;
  }
  ApertureCnt=i=0;
  while (i<MAXaperture && Prefs.aperture[i].number) {
    if (Prefs.aperture[i].category&mask) {
      ApertureToStr (AperturePtr[ApertureCnt], Prefs.aperture[i].number);
      ApertureCnt++;
    }
    i++;
  }
  LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_focal)), FocalPtr, FocalCnt);
  LstSetHeight (lst, (FocalCnt<8)?FocalCnt:8);
  LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_aperture)), AperturePtr, ApertureCnt);
  LstSetHeight (lst, (ApertureCnt<8)?ApertureCnt:8);
// focal
  if (Record.focal) {
    for (i=ofs=0; i<MAXfocal; i++) {
      if (Prefs.focal[i].category&mask) {
	if (Prefs.focal[i].length==Record.focal) {
	  LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_focal)), ofs);
	  break;
	}
	ofs++;
      }
    }
  } else
  if (FocalCnt==1)
    CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_focal)), FocalPtr[0]);
// aperture
  if (Record.aperture) {
    for (i=ofs=0; i<MAXaperture; i++) {
      if (Prefs.aperture[i].category&mask) {
	if (Prefs.aperture[i].number==Record.aperture) {
	  LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_aperture)), ofs);
	  break;
	}
	ofs++;
      }
    }
  }
}

// save data from form to database
static void UnLoadData (void) {
FormPtr     frm;
ControlPtr  ctl;
ListPtr     lst;
Ptr         p;
int         i;

  if ((frm=FrmGetFormPtr (record_form))==0) return;
//  if (Index==DmNumRecords (FilmDB)-1) {
// optionally boolean value if allow/disallow editing old fields
// copy from form to variable
    if ((i=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_lens))))!=noListSelection)
      StrCopy (Record.lens, Prefs.lens[i]);
    else
      Record.lens[0]='\0';
    Record.focal=StrGetVal (CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_focal))), 0);
    Record.aperture=StrGetVal (CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_aperture))), 1);
    Record.speed=StrGetVal (CtlGetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_speed))), -1);
    i=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_correc)));
    if (i!=noListSelection && i>0)
      Record.correc=Prefs.correc[i-1];
    else
      Record.correc=0;
    i=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_filter)));
    if (i!=noListSelection && i>0)
      StrCopy (Record.filter, Prefs.filter[i-1]);
    else
      Record.filter[0]='\0';
    Record.flags=0;
    if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_AE)))) Record.flags|=AE;
    if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_AElock)))) Record.flags|=AElock;
    if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_tripod)))) Record.flags|=Tripod;
    if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_flash)))) Record.flags|=Flash;
    StrCopy (Record.descrip, MemHandleLock (descripHnd));
    MemHandleUnlock (descripHnd);
// save variable to database
    WriteRecord (&Record);
//  }
// freeing memory handles and pointers
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_descrip)), NULL);
  ActiveForm=0;
}

// prepare preferences form
// 1 initialization of all components
// 2 initialization of popup lens menu
static void LoadPrefs (int init) {
FormPtr     frm;
ControlPtr  ctl;
ListPtr     lst;
char        mask;
int         i, ofs;
UInt        objIndex;

  if ((frm=FrmGetFormPtr (prefs_form))==0) return;
// variables initialization
  if (init==1) {
    PrefsCat=PrefsObj=0;
    for (i=ofs=0; i<MAXprefs; i++, ofs+=MAXsize) PrefsPtr[i]=&ListStr[ofs];
    for (i=0; i<MAXlens; i++, ofs+=LensSize) LensPtr[i]=&ListStr[ofs];
    for (i=0; i<MAXaperture; i++, ofs+=ApertureSize) AperturePtr[i]=&ListStr[ofs];
// set preferences type
    LstSetSelection (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_type)), PrefsCat);
    CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, prefs_type)), LstGetSelectionText (lst, PrefsCat));
  }
// if 1 or 2 set lens type for lens popup trigger
  LensCnt=ApertureCnt=PrefsCnt=0;
  objIndex=FrmGetObjectIndex (frm, prefs_lens);
// retrieve lens selection -> make mask
  if (PrefsCat==1 || PrefsCat==2) {
    i=0;
    while (i<MAXlens && Prefs.lens[i][0]) {
      StrCopy (LensPtr[LensCnt], Prefs.lens[i]);
      LensCnt++; i++;
    }
    if (PrefsObj+1>LensCnt) PrefsObj=LensCnt-1;
    if (PrefsObj<0) PrefsObj=0;
    mask=1<<PrefsObj;
// set lens popup list and trigger
    LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_p_lens)), LensPtr, LensCnt);
    LstSetHeight (lst, LensCnt);
    if (init==2) {
      LstSetSelection (lst, PrefsObj);
      CtlSetLabel (FrmGetObjectPtr (frm, objIndex), LstGetSelectionText (lst, PrefsObj));
    }
    FrmShowObject (frm, objIndex);
  } else
    FrmHideObject (frm, objIndex);
// set other lists
  switch (PrefsCat) {
    case 0: //lens
      PrefsMax=MAXlens; i=0;
      while (i<MAXlens && Prefs.lens[i][0]) {
	StrCopy (PrefsPtr[PrefsCnt], Prefs.lens[i]);
	PrefsCnt++; i++;
      }
      break;
    case 1: //focal
      PrefsMax=MAXfocal; i=0;
      while (i<MAXfocal && Prefs.focal[i].length) {
	FocalToStr (PrefsPtr[PrefsCnt], Prefs.focal[i].length);
	if (Prefs.focal[i].category&mask) {
	  StrCopy (AperturePtr[ApertureCnt], PrefsPtr[PrefsCnt]);
	  ApertureCnt++;
	}
	PrefsCnt++; i++;
      }
      break;
    case 2: //aperture
      PrefsMax=MAXaperture; i=0;
      while (i<MAXaperture && Prefs.aperture[i].number) {
	ApertureToStr (PrefsPtr[PrefsCnt], Prefs.aperture[i].number);
	if (Prefs.aperture[i].category&mask) {
	  StrCopy (AperturePtr[ApertureCnt], PrefsPtr[PrefsCnt]);
	  ApertureCnt++;
	}
	PrefsCnt++; i++;
      }
      break;
    case 3: //speed
      PrefsMax=MAXspeed; i=0;
      while (i<MAXspeed && Prefs.speed[i]) {
	SpeedToStr (PrefsPtr[PrefsCnt], Prefs.speed[i]);
	PrefsCnt++; i++;
      }
      break;
    case 4: //correction
      PrefsMax=MAXcorrec; i=0;
      while (i<MAXcorrec && Prefs.correc[i]) {
	CorrecToStr (PrefsPtr[PrefsCnt], Prefs.correc[i]);
	PrefsCnt++; i++;
      }
      break;
    case 5: //filter
      PrefsMax=MAXfilter; i=0;
      while (i<MAXfilter && Prefs.filter[i][0]!='\0') {
	StrCopy (PrefsPtr[PrefsCnt],Prefs.filter[i]);
	PrefsCnt++; i++;
      }
      break;
  }
// set first list
  LstSetListChoices (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_prefsall)), PrefsPtr, PrefsCnt);
// possibly set second
  lst=FrmGetObjectPtr (frm, objIndex=FrmGetObjectIndex (frm, list_prefsel));
  if (PrefsCat==1 || PrefsCat==2) {
    LstSetListChoices (lst, AperturePtr, ApertureCnt);
    FrmShowObject (frm, objIndex);
    lst->attr.usable=true; // for PalmOS < 3.5
  } else {
    FrmHideObject (frm, objIndex);
    lst->attr.usable=false; // for PalmOS < 3.5
    LstEraseList (lst); // because the form is not redrawn
  }
// buttons >> and <<
  objIndex=FrmGetObjectIndex (frm, prefs_add);
  if (PrefsCat==1 || PrefsCat==2)
    FrmShowObject (frm, objIndex);
  else
    FrmHideObject (frm, objIndex);
  objIndex=FrmGetObjectIndex (frm, prefs_remove);
  if (PrefsCat==1 || PrefsCat==2)
    FrmShowObject (frm, objIndex);
  else
    FrmHideObject (frm, objIndex);
  FrmDrawForm (frm);
  ActiveForm=prefs_form;
}

// save preferences data
static void UnLoadPrefs (void) {
FormPtr frm;
Ptr     p;
// save preferences data to database
  p=MemHandleLock (DmGetRecord (PrefsDB, 0));
  DmWrite (p, 0, &Prefs, sizeof (struct sPrefs));
  MemPtrUnlock (p);
  DmReleaseRecord (PrefsDB, 0, true);
  ActiveForm=0;
}

// main event loop
static void EventLoop(void) {
short       err;
int         formID;
FormPtr     form;
EventType   event;

  do {
    EvtGetEvent (&event, sysTicksPerSecond*8);
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
// application handle event...
    if (event.eType==nilEvent) {
      if (MenuGetActiveMenu ()!=NULL) continue;
      if (ActiveForm!=record_form || Index<(DmNumRecords (FilmDB)-1)) continue;
      Record.DateTime=TimGetSeconds ();
      FillView (1);
      form = FrmGetFormPtr (record_form);
      CtlSetLabel (FrmGetObjectPtr (form, FrmGetObjectIndex (form, record_date)), ctl_date);
      CtlSetLabel (FrmGetObjectPtr (form, FrmGetObjectIndex (form, record_time)), ctl_time);
      continue;
    }
    if (event.eType == frmLoadEvent) {
      formID = event.data.frmLoad.formID;
      form = FrmInitForm (formID);
      ctl_lens=NULL;
      FrmSetActiveForm (form);
      switch (formID) {
	case record_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) FotoPadEnter);
	  break;
	case prefs_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) FotoPadPrefs);
	  break;
      }
    }
    FrmDispatchEvent (&event);
  } while (event.eType != appStopEvent);
}

// new picture form event handler
static Boolean FotoPadEnter (EventPtr event) {
VoidHand        RecHandle;
Ptr             RecPointer;
FormPtr         frm;
ListPtr         lst;
ControlPtr      ctl;
int             handled = 0;
char            *s;
FieldType       *fld;
int             objIndex, strpos, k;
LocalID         db_id;
DateTimeType    DateTime;
Boolean         caps, num, ashft;
UInt16          shft;

  frm = FrmGetActiveForm ();
  switch (event->eType) {
    case frmOpenEvent:
      FrmDrawForm (frm);
      LoadData (1);
      handled = 1;
      break;

    case keyDownEvent: // HW button was pressed
      switch (event->data.keyDown.chr) {
	case chrPageUp:
	  goto DoRecordMinus;
	case chrPageDown:
	  goto DoRecordPlus;
	default:
	  if (FrmGetFocus (frm)!=(objIndex=FrmGetObjectIndex (frm, record_descrip))) {
	    if (RecHandle=(VoidHand)FldGetTextHandle (fld=FrmGetObjectPtr (frm, objIndex))) {
	      strpos=StrLen (MemHandleLock (RecHandle)); MemHandleUnlock (RecHandle);
	      FldSetInsertionPoint (fld, strpos);
	      FrmSetFocus (frm, objIndex);
	    }
	  }
	  break;
      }
      break;

    case fldChangedEvent:
      UpdateScrollbar (frm, record_descrip, record_scroll);
      handled=1;
      break;

    case sclRepeatEvent:
      ScrollLines (frm, record_descrip, record_scroll, event->data.sclRepeat.newValue - event->data.sclRepeat.value, false);
      break;

    case ctlSelectEvent:  // A control button was pressed and released.
      switch (event->data.ctlEnter.controlID) {
	case record_next:
	  if (Index!=DmNumRecords (FilmDB)-1) break;
	  UnLoadData ();
	  Index++;
	  ClearRecord ();
	  WriteRecord (&Record);
	  LoadData (2);
	  handled = 1;
	  break;
	case record_copy:
	  if (!Index) break;
	  Index--;
	  LoadData (2);
	  Index++;
	  WriteRecord (&Record);
	  LoadData (2);
	  handled = 1;
	  break;
	case record_minus:
DoRecordMinus:
	  if (Index) {
	    UnLoadData ();
	    Index--;
	    LoadData (2);
	  }
	  handled=1;
	  break;
	case record_plus:
DoRecordPlus:
	  if (Index<DmNumRecords (FilmDB)-1) {
	    UnLoadData ();
	    Index++;
	    LoadData (2);
	  }
	  handled=1;
	  break;
	case record_picture: // fast selecting of picture number - no idea how to do that
	  handled=1;
	  break;
	case record_date: // invoking system dialog for selecting new date
	case record_time: // invoking system dialog for selecting new time
	  TimSecondsToDateTime (Record.DateTime, &DateTime);
	  if (event->data.ctlEnter.controlID==record_date) {
	    if (!SelectDay (selectDayByDay, &DateTime.month, &DateTime.day, &DateTime.year, "")) break;
	  } else {
	    if (!SelectOneTime (&DateTime.hour, &DateTime.minute, "")) break;
	  }
	  Record.DateTime=TimDateTimeToSeconds (&DateTime);
	  FillView (1);
	  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_date)), ctl_date);
	  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_time)), ctl_time);
	  handled=1;
	  break;
      }
      break;

    case menuEvent: // menu item was selected
      switch (event->data.menu.itemID) {
	case menu_newfilm:
	  if (FilmCnt>=MAXfilm) break;
	  FilmPtr[FilmCnt][0]='\0';
	  StrCopy (MemHandleLock (valueHnd), FilmPtr[FilmCnt]); MemHandleUnlock (valueHnd);
	  if (EnterValue (FilmPtr[FilmCnt], false)!=enter_ok) break;
	  FilmSel=FilmCnt++;
	  UnLoadData ();
	  DmCloseDatabase (FilmDB);
	  ClearRecord ();
	  OpenDatabase (1);
	  LoadData (2);
	  break;
	case menu_rename:
	  if (!(db_id=DmFindDatabase (card, FilmPtr[FilmSel]))) break;
	  if (EnterValue (FilmPtr[FilmSel], true)!=enter_ok) break;
	  DmSetDatabaseInfo (card, db_id, FilmPtr[FilmSel], NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_film)), FilmPtr[FilmSel]);
	  break;
	case menu_delete:
	  if (FilmCnt<2) break;
	  if (!(db_id=DmFindDatabase (card, FilmPtr[FilmSel]))) break;
	  if (FrmAlert (delete_alert)) break;
	  UnLoadData ();
	  DmCloseDatabase (FilmDB);
	  DmDeleteDatabase (card, db_id);
	  FilmCnt--;
	  for (objIndex=FilmSel; objIndex<FilmCnt; objIndex++) StrCopy (FilmPtr[objIndex], FilmPtr[objIndex+1]);
	  if (FilmSel>FilmCnt-1) FilmSel=FilmCnt-1;
	  OpenDatabase (1);
	  LoadData (2);
	  break;
	case menu_lastpict:
	  if (Index==DmNumRecords (FilmDB)-1) break;
	  UnLoadData ();
	  Index=DmNumRecords (FilmDB)-1;
	  MenuEraseStatus (NULL);
	  LoadData (2);
	  break;
	case menu_about:
	  FrmHelp (str_about);
	  break;
	case menu_copy:
	  FldCopy (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_descrip)));   // user has to select (highlight) the text to copy
	  break;
	case menu_paste:
	  FldPaste(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_descrip)));
	  break;
	case menu_cut:
	  FldCut (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_descrip)));
	  break;
	case menu_undo:
	  FldUndo (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_descrip)));
	  break;
	case menu_selall:
	  k=StrLen (MemHandleLock (RecHandle=(VoidHand)FldGetTextHandle (fld=FrmGetObjectPtr (frm, record_descrip))));
	  MemHandleUnlock (RecHandle);
	  FldSetSelection (fld, 0, k);
	  break;
	case menu_keyboard:
	  SysKeyboardDialog (kbdAlpha);
	  break;
	case menu_grf_help:
	  GrfGetState (&caps, &num, &shft, &ashft);
	  SysGraffitiReferenceDialog ((shft==grfTempShiftPunctuation)?referencePunc1:((shft==grfTempShiftExtended)?referenceExtended:referenceAlpha));
	  break;
	case menu_prefs:
	  UnLoadData ();
	  FrmGotoForm (prefs_form);
	  break;
      }
      handled = 1;
      break;

    case popSelectEvent:
      switch (event->data.popSelect.listID) {
      case list_film:
	if ((objIndex=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_film))))==noListSelection) break;
	UnLoadData ();
	DmCloseDatabase (FilmDB);
	FilmSel=objIndex;
	OpenDatabase (1);
	FrmGotoForm (record_form);
	handled=1;
	break;
      case list_lens:
	UpdateRecordForm ();
	break;
      case list_speed:
	lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_speed));
	if (StrCompare (LstGetSelectionText (lst, LstGetSelection (lst)), UnlistedSpeed)) break;
// entering user specific (unlisted) speed
	objIndex=StrGetVal (CtlGetLabel (ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, record_speed))), -1);
	if (objIndex)
	  SpeedToStr (ViewRec.speed, objIndex);
	else
	  ViewRec.speed[0]='\0';
	handled=1;
	if (EnterValue (ViewRec.speed, true)!=enter_ok) break;
	if (!(objIndex=StrGetVal (ViewRec.speed, -1))) break;
	SpeedToStr (ViewRec.speed, objIndex);
	CtlSetLabel (ctl, ViewRec.speed);
	break;
      }
      break;
  }
  return handled;
}

// preferences form event handler
static Boolean FotoPadPrefs (EventPtr event) {
FormPtr     frm;
int         handled = 0;
int         i, pos, bufi;
char        *s, mask, bufs[MAXsize], buff;
Ptr         p;
RectangleType rect;
struct CatAux *cat;

  frm=FrmGetActiveForm ();
  PrefsPos=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_prefsall)));
  switch (event->eType) {
    case frmOpenEvent:
      LoadPrefs (1);
      handled = 1;
      break;

    case ctlSelectEvent:  // A control button was pressed and released.
      switch (event->data.ctlEnter.controlID) {
	case prefs_new:
	  if (PrefsCnt>=PrefsMax) break;
	  bufs[0]='\0';
	  PrefsPos=PrefsCnt;
	  goto EditValue;
	case prefs_edit:
	  if (!PrefsCnt || PrefsPos==noListSelection) break;
	  switch (PrefsCat) {
	  case 0: // lens
	    StrCopy (bufs, Prefs.lens[PrefsPos]);
	    break;
	  case 1: // focal
	    FocalToStr (bufs, Prefs.focal[PrefsPos].length);
	    break;
	  case 2: // aperture
	    ApertureToStr (bufs, Prefs.aperture[PrefsPos].number);
	    break;
	  case 3: // speed
	    SpeedToStr (bufs, Prefs.speed[PrefsPos]);
	    break;
	  case 4: // correction
	    CorrecToStr (bufs, Prefs.correc[PrefsPos]);
	    break;
	  case 5: // filter
	    StrCopy (bufs, Prefs.filter[PrefsPos]);
	    break;
	  }
EditValue:
	  if (EnterValue (bufs, true)!=enter_ok) break;
	  switch (PrefsCat) {
	  case 0: // lens
	    StrCopy (Prefs.lens[PrefsPos], bufs);
	    break;
	  case 1: // focal
	    Prefs.focal[PrefsPos].length=StrGetVal (bufs, 0);
	    Prefs.focal[PrefsPos].category=0;
	    break;
	  case 2: // aperture
	    Prefs.aperture[PrefsPos].number=StrGetVal (bufs, 1);
	    Prefs.aperture[PrefsPos].category=0;
	    break;
	  case 3: // speed
	    Prefs.speed[PrefsPos]=StrGetVal (bufs, -1);
	    break;
	  case 4: // correction
	    Prefs.correc[PrefsPos]=StrGetVal (bufs, 1)+1000;
	    break;
	  case 5: // filter
	    StrCopy (Prefs.filter[PrefsPos], bufs);
	    break;
	  }
	  LoadPrefs (0);
	  handled=1;
	  break;
	case prefs_delete:
	  if (!PrefsCnt || PrefsPos==noListSelection) break;
// move following data backwards
	  for (i=PrefsPos; (i+1)<PrefsCnt; i++) {
	    switch (PrefsCat) {
	    case 0: // lens
	      StrCopy (Prefs.lens[i], Prefs.lens[i+1]);
	      break;
	    case 1: // focal
	      Prefs.focal[i].length=Prefs.focal[i+1].length;
	      Prefs.focal[i].category=Prefs.focal[i+1].category;
	      break;
	    case 2: // aperture
	      Prefs.aperture[i].number=Prefs.aperture[i+1].number;
	      Prefs.aperture[i].category=Prefs.aperture[i+1].category;
	      break;
	    case 3: // speed
	      Prefs.speed[i]=Prefs.speed[i+1];
	      break;
	    case 4: // correction
	      Prefs.correc[i]=Prefs.correc[i+1];
	      break;
	    case 5: // filter
	      StrCopy (Prefs.filter[i], Prefs.filter[i+1]);
	      break;
	    }
	  }
	  PrefsCnt--;
// erase last position
	  switch (PrefsCat) {
	  case 0: // lens
	    Prefs.lens[PrefsCnt][0]='\0';
	    break;
	  case 1: // focal
	    Prefs.focal[PrefsCnt].length=0;
	    Prefs.focal[PrefsCnt].category=0;
	    break;
	  case 2: // aperture
	    Prefs.aperture[PrefsCnt].number=0;
	    Prefs.aperture[PrefsCnt].category=0;
	    break;
	  case 3: // speed
	    Prefs.speed[PrefsCnt]=0;
	    break;
	  case 4: // correction
	    Prefs.correc[PrefsCnt]=0;
	    break;
	  case 5: // filter
	    Prefs.filter[PrefsCnt][0]='\0';
	    break;
	  }
	  LoadPrefs (0);
	  handled=1;
	  break;
	case prefs_up:
	  if (PrefsCnt<2 || PrefsPos==noListSelection || !PrefsPos) break;// || !PrefsCat) break;
	  i=-1;
	  goto DoPrefsSwitch;
	case prefs_down:
	  if (PrefsCnt<2 || PrefsPos==noListSelection || PrefsPos+1==PrefsCnt) break;// || !PrefsCat) break;
	  i=1;
DoPrefsSwitch:
	  switch (PrefsCat) {
	  case 0: // lens
	    StrCopy (bufs, Prefs.lens[PrefsPos]);
	    StrCopy (Prefs.lens[PrefsPos], Prefs.lens[PrefsPos+i]);
	    StrCopy (Prefs.lens[PrefsPos+i], bufs);
	    // There shoould be resorting of lens flags for focal and aperture categories
	    mask=(1<<PrefsPos)|(1<<(PrefsPos+i));
	    for (bufi=0; bufi<MAXfocal; bufi++) {
	      buff=Prefs.focal[bufi].category;
	      Prefs.focal[bufi].category=(buff&(~mask))|(((buff&mask)>>1)&mask)|(((buff&mask)<<1)&mask);
	    }
	    for (bufi=0; bufi<MAXaperture; bufi++) {
	      buff=Prefs.aperture[bufi].category;
	      Prefs.aperture[bufi].category=(buff&(~mask))|(((buff&mask)>>1)&mask)|(((buff&mask)<<1)&mask);
	    }
	    break;
	  case 1: // focal
	    bufi=Prefs.focal[PrefsPos].length;
	    buff=Prefs.focal[PrefsPos].category;
	    Prefs.focal[PrefsPos].length=Prefs.focal[PrefsPos+i].length;
	    Prefs.focal[PrefsPos].category=Prefs.focal[PrefsPos+i].category;
	    Prefs.focal[PrefsPos+i].length=bufi;
	    Prefs.focal[PrefsPos+i].category=buff;
	    break;
	  case 2: // aperture
	    bufi=Prefs.aperture[PrefsPos].number;
	    buff=Prefs.aperture[PrefsPos].category;
	    Prefs.aperture[PrefsPos].number=Prefs.aperture[PrefsPos+i].number;
	    Prefs.aperture[PrefsPos].category=Prefs.aperture[PrefsPos+i].category;
	    Prefs.aperture[PrefsPos+i].number=bufi;
	    Prefs.aperture[PrefsPos+i].category=buff;
	    break;
	  case 3: // speed
	    bufi=Prefs.speed[PrefsPos];
	    Prefs.speed[PrefsPos]=Prefs.speed[PrefsPos+i];
	    Prefs.speed[PrefsPos+i]=bufi;
	    break;
	  case 4: // correction
	    bufi=Prefs.correc[PrefsPos];
	    Prefs.correc[PrefsPos]=Prefs.correc[PrefsPos+i];
	    Prefs.correc[PrefsPos+i]=bufi;
	    break;
	  case 5: // filter
	    StrCopy (bufs, Prefs.filter[PrefsPos]);
	    StrCopy (Prefs.filter[PrefsPos], Prefs.filter[PrefsPos+i]);
	    StrCopy (Prefs.filter[PrefsPos+i], bufs);
	    break;
	  }
	  LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_prefsall)), PrefsPos+i);
	  LoadPrefs (0);
	  handled=1;
	  break;
	case prefs_add:
	  if (!PrefsCnt || PrefsPos==noListSelection || PrefsCat<1 || PrefsCat>2) break;
	  switch (PrefsCat) {
	  case 1: // focal
	    Prefs.focal[PrefsPos].category|=(1<<PrefsObj);
	    break;
	  case 2: // aperture
	    Prefs.aperture[PrefsPos].category|=(1<<PrefsObj);
	    break;
	  }
	  LoadPrefs (0);
	  handled=1;
	  break;
	case prefs_remove:
	  if ((pos=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_prefsel))))==noListSelection || PrefsCat<1 || PrefsCat>2) break;
	  pos++; i=0;
	  mask=1<<PrefsObj;
	  switch (PrefsCat) {
	  case 1: // focal
	    while (i<MAXfocal && pos) {if (Prefs.focal[i].category&mask) pos--; i++;}
	    if (pos) break;
	    i--;
	    Prefs.focal[i].category&=~mask;
	    break;
	  case 2: // aperture
	    while (i<MAXaperture && pos) {if (Prefs.aperture[i].category&mask) pos--; i++;}
	    if (pos) break;
	    i--;
	    Prefs.aperture[i].category&=~mask;
	    break;
	  }
	  LoadPrefs (0);
	  handled=1;
	  break;
	case prefs_ok:
	  UnLoadPrefs ();
	  FrmGotoForm (record_form);
	  handled = 1;
	  break;
      }
      break;
    case menuEvent:
      switch (event->data.menu.itemID) {
	case menu_about:
	  FrmHelp (str_about);
	  break;
      }
    case popSelectEvent: // listbox item selection
      switch (event->data.popSelect.listID) {
	case list_type: // category selection: aperture, speed...
	  if (event->data.popSelect.selection==noListSelection) break;
	  PrefsCat=event->data.popSelect.selection;
	  LoadPrefs (2);
//          handled=1; // if handled=1 PalmOS doesn't do autoomatic popup trigger label update
	  break;
	case list_p_lens: // lens selection for second listbox
	  if (event->data.popSelect.selection==noListSelection) break;
	  PrefsObj=event->data.popSelect.selection;
	  LoadPrefs (0);
//          handled=1; // if handled=1 PalmOS doesn't do autoomatic popup trigger label update
	  break;
      }
      break;
  }
  return handled;
}

// open modal dialog for string modification
static int EnterValue (char *val, Boolean sel) {
FormPtr     newfrm, oldfrm;
FieldPtr    fld;
int         retval;

  InsPtEnable (false);
  StrCopy (MemHandleLock (valueHnd), val); MemHandleUnlock (valueHnd);
  newfrm=FrmInitForm (enter_form);
//  oldfrm=FrmGetActiveForm ();
//  FrmSetActiveForm (newfrm);
//  FrmSetEventHandler (newfrm, FotoPadNewVal);
  FldSetTextHandle (fld=FrmGetObjectPtr (newfrm, retval=FrmGetObjectIndex (newfrm, enter_value)), (Handle)valueHnd);
  if (sel) FldSetSelection (fld, 0, StrLen (val));
  FrmDrawForm (newfrm);
  FrmSetFocus (newfrm, retval);
  retval=FrmDoDialog (newfrm);
  FldSetTextHandle (fld, NULL);
//  FrmDeleteForm (newfrm);
  if (retval==enter_ok) {StrCopy (val, MemHandleLock (valueHnd)); MemHandleUnlock (valueHnd);}
  InsPtEnable (true);
//  FrmSetActiveForm (oldfrm);
  return retval;
}
// template for Preference's categories switch
/**
	  switch (PrefsCat) {
	  case 0: // lens
	    break;
	  case 1: // focal
	    break;
	  case 2: // aperture
	    break;
	  case 3: // speed
	    break;
	  case 4: // correc
	    break;
	  case 5: // filter
	    break;
	  }
**/
