/* FotoPad 0.95
 * (C) MAR-APR 2001 Hynek Sladky
 * sladky@mujmail.cz
 */

// database type definition
#define AppID           'FPad'
#define PrefsDBType     'Pref'
#define FilmDBType      'Film'

// global constants definition
#define MAXfilm         16
#define FnameSize       32

#define MAXlens         8
#define MAXfocal        24
#define MAXaperture     24
#define MAXspeed        30
#define MAXfilter       20
#define MAXcorrec       20
#define MAXprefs        30

#define LensSize        16
#define FocalSize       8
#define ApertureSize    8
#define SpeedSize       8
#define CorrecSize      8
#define FilterSize      16
// was 41, now is 4000 and the record is compressed before writing
#define DescripSize     4001
// maximal difference for not-resizing the record
#define MaxDifference   10
#define MAXsize         16

// preferences structure
struct sPrefs {
  char lens[MAXlens][LensSize];
  struct {
    UInt length;
    char category;
  } focal[MAXfocal];
  struct {
    UInt number;
    char category;
  } aperture[MAXaperture];
  int speed[MAXspeed];
  int correc[MAXcorrec];
  char filter[MAXfilter][FilterSize];
};

// film record structure
struct sRecord {
  unsigned long DateTime;
  char lens[LensSize];
  UInt focal;
  UInt aperture;
  int speed;
  int correc;
  char flags;
  char filter[FilterSize];
  char descrip[DescripSize];
};
// check boxes bit mask
#define AE      0x01
#define AElock  0x02
#define Tripod  0x04
#define Flash   0x08

// view record structure
struct sView {
  char focal[10];
  char aperture[10];
  char speed[10];
  char correc[10];
};
